unit WinTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Menus, Buttons, ToolWin ;

type
  TForm1 = class(TForm)
    GBParametry: TGroupBox;
    CBPort: TComboBox;
    CBPredkosc: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    ETime: TEdit;
    Label5: TLabel;
    GBDaneSt: TGroupBox;
    EditStatus: TEdit;
    EditStZmiana: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    GBTest: TGroupBox;
    Label1: TLabel;
    EditLicznik: TEdit;
    EditStatusOK: TEdit;
    EditStatusBe: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    GBBledy: TGroupBox;
    EditTNad: TEdit;
    EditTOdb: TEdit;
    EditBledy: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    StatusBar1: TStatusBar;
    EditZlaOdp: TEdit;
    Label12: TLabel;
    EditNak: TEdit;
    Label13: TLabel;
    Timer1: TTimer;
    EditCzas: TEdit;
    LabelCzas: TLabel;
    MainMenu1: TMainMenu;
    Testy: TMenuItem;
    StartBajt: TMenuItem;
    Paragon1: TMenuItem;
    Stawki: TMenuItem;
    Koniec: TMenuItem;
    Stop: TMenuItem;
    Obsugaportu1: TMenuItem;
    InicjujPort: TMenuItem;
    ZamknijPort: TMenuItem;
    ToolBar1: TToolBar;
    SBInicjujPort: TSpeedButton;
    SBZamknijPort: TSpeedButton;
    SBParagon3: TSpeedButton;
    SBKorekta: TSpeedButton;
    Paragonzkorekt1: TMenuItem;
    N2: TMenuItem;
    SBStawki: TSpeedButton;
    SBRaport: TSpeedButton;
    Raportdobowy1: TMenuItem;
    SBWyswietlacz: TSpeedButton;
    Wyswietlacz: TMenuItem;
    SBStawkiVat: TSpeedButton;
    Wprowadstawki1: TMenuItem;
    SBOdczytajStawki: TSpeedButton;
    SpeedButton1: TSpeedButton;

    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Paragon1Click(Sender: TObject);
    procedure InicjujPortClick(Sender: TObject);
    procedure ZamknijPortClick(Sender: TObject);
    procedure SBStawkiClick(Sender: TObject);
    procedure CzyscPola;
    procedure SBKorektaClick(Sender: TObject);
    procedure KoniecParagonuWTrybieBlokowym;
    procedure PozycjaSprzedazy;
    procedure StopClick(Sender: TObject);
    procedure StartBajtClick(Sender: TObject);
    procedure KoniecClick(Sender: TObject);
    procedure SBRaportClick(Sender: TObject);
    procedure SBWyswietlaczClick(Sender: TObject);
    procedure SBStawkiVatClick(Sender: TObject);
    procedure SBOdczytajStawkiClick(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }
  end;

type tBuforBajtow = Array[1..256] of Byte;

const WinSeria = 'WinSeria.dll';
      function iInitializePort(NrPortu:integer; SzybkoscTransmisji :integer;
                      TimeoutNadawania, TimeoutOdbierania :integer):integer;
               StdCall;

      function InitializePort(NrPortu:byte;SzybkoscTransmisji:dword;
                      TimeoutNadawania,TimeoutOdbierania:dword):integer;
               StdCall;

      function UnInitializePort:integer; StdCall;


      function IsError(var OpisBledu:PChar; var KodBledu:integer): boolean;
               StdCall;

      function RSSequence(KodSterujacy:byte; LiczbaBajtowDoOdebrania:byte;
                      LiczbaBajtowDoPoslania:byte;
                      var BuforBajtowOdebranych:tBuforBajtow;
                      BuforBajtowDoPoslania:tBuforBajtow):byte; StdCall;


var
  Form1        :TForm1;
  Przerwij     :boolean;
  Odswierz     :boolean;
  Czas         :dword;
  MozliwaPraca :boolean;
  BufBajtowOdebr    :tBuforBajtow;
  BufBajtowDoPOsl   :tBuforBajtow;
  Wynik :byte;

implementation
  function InitializePort; external WinSeria;
  function iInitializePort; external WinSeria;
  function UnInitializePort; external WinSeria;
  function IsError; external WinSeria;
  function RSSequence; external WinSeria ;

{$R *.DFM}

{******************************************************************************}
{pocztkowe ustawienia}
{******************************************************************************}

procedure TForm1.FormCreate(Sender: TObject);
begin
  CBPort.ItemIndex:=1;
  CBPredkosc.ItemIndex:=0;
end;

{******************************************************************************}
{odmierzaj czas}
{******************************************************************************}

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Odswierz := true;
  Czas := round(Timer1.Interval/1000)+Czas;
  EditCzas.Text := IntToStr(Czas);
end;

{******************************************************************************}
{sprawd poprawno inicjalizacji}
{******************************************************************************}

function JestBladInit:boolean;
var pErrMsg  :PChar;
    iErrCode :integer;
    sErrMsg  :string;
begin
  Result := false;
  pErrMsg := StrAlloc(256);
  IsError(pErrMsg,iErrCode);
  sErrMsg := StrPas(pErrMsg);

  Form1.StatusBar1.Panels[1].Text := sErrMsg;
  Form1.StatusBar1.Panels[0].Text := 'Numer bdu: ' +IntToStr(iErrCode);

  if iErrCode > 0 then Result := true;
  StrDispose(pErrMsg);
end;

{******************************************************************************}
{inicjuj port szeregowy}
{******************************************************************************}

procedure TForm1.InicjujPortClick(Sender: TObject);
var
    NrPort   :integer;
    TimeO    :integer;
    BaudRate :integer;
begin
  TimeO := StrToInt(ETime.Text);
  NrPort := CBPort.ItemIndex+1;
  BaudRate := StrToInt(CBPredkosc.Text);  {szybko transmisji}
  ETime.Color := clBtnFace;
  ETime.ReadOnly := true;

  if iInitializePort(NrPort,BaudRate,TimeO,TimeO) > 0 then begin
     JestBladInit;
     MozliwaPraca := false;
     exit;
  end;
  CBPort.Color := clBtnFace;
  CBPort.Enabled := false;
  CBPredkosc.Color := clBtnFace;
  CBPredkosc.Enabled := false;
  MozliwaPraca := true;
end;

{******************************************************************************}
{zwolnij port szeregowy}
{******************************************************************************}

procedure TForm1.ZamknijPortClick(Sender: TObject);
begin
  MozliwaPraca := false;
  UnInitializePort;
  Form1.StatusBar1.Panels[1].Text :='';
  Form1.StatusBar1.Panels[0].Text :='';
  CBPort.Color := clWindow;
  CBPort.Enabled := true;
  CBPredkosc.Color := clWindow;
  CBPredkosc.Enabled := true;
  ETime.Color := clWindow;
  ETime.ReadOnly := false;
end;

{******************************************************************************}
{zwraca bajt KtoryBajt z przedziau [1..4] z podanej liczby}
{******************************************************************************}

function BajtZLiczby(Liczba:longint; KtoryBajt:integer):byte;
var  LiczbaPom :longint;
begin
  case KtoryBajt of
      1: result := (Liczba and $FF);
      2: begin
           LiczbaPom := (Liczba and $FF00);
           result := trunc(LiczbaPom/$FF );
         end;
      3: begin
           LiczbaPom := (Liczba and $FF0000);
           result := trunc(LiczbaPom/$FF00 );
         end;
      4: begin
           LiczbaPom := (Liczba and $FF000000);
           result := trunc(LiczbaPom/$FF0000 );
         end;
  else
   result := 0;
  end;
end;

{******************************************************************************}
{paragon w trybie blokowym }
{******************************************************************************}

procedure TForm1.Paragon1Click(Sender: TObject);
var i             :integer;
begin
  CzyscPola;

  if not MozliwaPraca then begin
    MessageDlg('Nie zainicjowany port', mtInformation, [mbOk], 0);
    exit;
  end;

  FillChar(BufBajtowDoPosl,SizeOf(BufBajtowOdebr),0);
  for i := 1 to 4 do
     BufBajtowDoPosl[i] := BajtZLiczby(20000, i);
  FillChar(BufBajtowOdebr,SizeOf(BufBajtowOdebr),0);
  //rozpoczcie paragonu w trybie blokowym
  Wynik := RSSequence($20,1,4,BufBajtowOdebr,BufBajtowDoPosl);

  if WYnik <> 0 then
      MessageDlg('Paragon nie moe by wystawiony', mtInformation, [mbOk], 0)
  else
    begin
      PozycjaSprzedazy;
       //wysanie pozycji sprzeday
      Wynik := RSSequence($06,0,49,BufBajtowOdebr,BufBajtowDoPosl);
      if Wynik <> 0 then begin
        MessageDlg('Bdny wynik posania sekwecji', mtInformation, [mbOk], 0);
        exit;
      end;

      PozycjaSprzedazy;
       //wysanie pozycji sprzeday
      Wynik := RSSequence($06,0,49,BufBajtowOdebr,BufBajtowDoPosl);
      if Wynik <> 0 then begin
        MessageDlg('Bdny wynik posania sekwecji', mtInformation, [mbOk], 0);
        exit;
      end;

      //zakoczenie paragonu
      KoniecParagonuWTrybieBlokowym;
    end;
end;

{******************************************************************************}
{wydruk kontrolny nazw i stawek towarowych}
{******************************************************************************}

procedure TForm1.SBStawkiClick(Sender: TObject);
var i     :integer;
    Nazwa :string;
begin
  CzyscPola;
  if not MozliwaPraca then begin
    MessageDlg('Nie zainicjowany port', mtInformation, [mbOk], 0);
    exit;
  end;

  FillChar(BufBajtowDoPosl,SizeOf(BufBajtowOdebr),0);
  FillChar(BufBajtowOdebr,SizeOf(BufBajtowOdebr),0);

  Nazwa := 'KASZKA MANNA 1kg           0';
  BufBajtowDoPosl[1] := $31;
  for i := 2 to 29 do
     BufBajtowDoPosl[i] := Ord(Nazwa[i-1]);

  Nazwa := 'CZEKOLADKI MILKY WAY        ';
  BufBajtowDoPosl[30] := $31;
  for i := 31 to 58 do
     BufBajtowDoPosl[i] := Ord(Nazwa[i-30]);

  Nazwa := 'CUKIER KRYSZTA BARDZO BIAY';
  BufBajtowDoPosl[59] := $31;
  for i := 60 to 87 do
     BufBajtowDoPosl[i] := Ord(Nazwa[i-59]);

  Nazwa := 'SL KUCHENNA Z WIELICZKI   0';
  BufBajtowDoPosl[88] := $31;
  for i := 89 to 116 do
     BufBajtowDoPosl[i] := Ord(Nazwa[i-87]);

  Nazwa := 'BUDY CZEKOLADOWY WINIARY  0';
  BufBajtowDoPosl[117] := $31;
  for i := 118 to 145 do
     BufBajtowDoPosl[i] := Ord(Nazwa[i-117]);

  Wynik := RSSequence($3F,0,145,BufBajtowOdebr,BufBajtowDoPosl);
  Wynik := RSSequence($51,1,0,BufBajtowOdebr,BufBajtowDoPosl);
  if Wynik <> 0 then
    MessageDlg('Wystpi bd nr ' + IntToStr(Wynik)+'.', mtInformation, [mbOk], 0)
end;

{******************************************************************************}
{czy pola tekstowe}
{******************************************************************************}
procedure TForm1.CzyscPola;
begin
  Form1.StatusBar1.Panels[1].Text := '';
  Form1.StatusBar1.Panels[0].Text := '';

  EditLicznik.Text := '0';
  EditTNad.Text := '0';
  EditTOdb.Text := '0';
  EditBledy.Text := '0';
  EditStatusOK.Text := '0';
  EditStatusBe.Text := '0';
  EditZlaOdp.Text := '0';
  EditNak.Text := '0';
  EditStZmiana.Text := '0';
  EditStatus.Text := '0';
  EditCzas.Text := '0';
end;

{******************************************************************************}
{paragon z jedn pozycj srzeday i jedn pozycj korekcyjn}
{******************************************************************************}

procedure TForm1.SBKorektaClick(Sender: TObject);
var i :integer;
begin
  CzyscPola;
  if not MozliwaPraca then begin
    MessageDlg('Nie zainicjowany port', mtInformation, [mbOk], 0);
    exit;
  end;

  FillChar(BufBajtowDoPosl,SizeOf(BufBajtowOdebr),0);
  FillChar(BufBajtowOdebr,SizeOf(BufBajtowOdebr),0);

  for i := 1 to 4 do
     BufBajtowDoPosl[i] := BajtZLiczby(0, i);
  FillChar(BufBajtowOdebr,SizeOf(BufBajtowOdebr),0);

  Wynik := RSSequence($20,1,4,BufBajtowOdebr,BufBajtowDoPosl);
  if Wynik <> 0 then begin
     MessageDlg('Nie mona wystawi paragonu', mtInformation,[mbOk], 0);
     exit;
  end;

  PozycjaSprzedazy;
  Wynik := RSSequence($06,0,49,BufBajtowOdebr,BufBajtowDoPosl);

  PozycjaSprzedazy;
  BufBajtowDoPosl[1] := $2D;
  Wynik := RSSequence($06,0,49,BufBajtowOdebr,BufBajtowDoPosl);
  if Wynik <> 0 then begin
     MessageDlg('Bdny wynik posania sekwecji', mtInformation, [mbOk], 0);
     exit;
  end;
  KoniecParagonuWTrybieBlokowym;
end;

{******************************************************************************}
{wypenienie danych o pozycji sprzeday}
{******************************************************************************}

procedure TForm1.PozycjaSprzedazy;
var Nazwa :string;
    i     :integer;
begin
  BufBajtowDoPosl[1] := $20;
  Nazwa := 'KASZKA MANNA 1kg            ';
  for i:= 2 to 29 do
   BufBajtowDoPosl[i] := Ord(Nazwa[i-1]);

  BufBajtowDoPosl[30] := $30;  //A1
  BufBajtowDoPosl[31] := $1;   //I1-I4
  BufBajtowDoPosl[32] := 0;
  BufBajtowDoPosl[33] := 0;
  BufBajtowDoPosl[34] := 0;
  BufBajtowDoPosl[35] := 0;    //M
  Nazwa := 'szt.';
  for i:= 1 to 4 do
   BufBajtowDoPosl[35+i] := Ord(Nazwa[i]); //J1

  for i := 1 to 4 do
    BufBajtowDoPosl[39+i] := BajtZLiczby(10000, i); //C1 40-43
  BufBajtowDoPosl[44] := $1B;  //ESC
  BufBajtowDoPosl[45] := $31;  //ST
  for i := 1 to 4 do
    BufBajtowDoPosl[45+i] := BajtZLiczby(10000, i); //W1 46-49
end;

{******************************************************************************}
{wysanie sekwencji koczcych paragon}
{******************************************************************************}

procedure TForm1.KoniecParagonuWTrybieBlokowym;
begin
  Wynik := RSSequence($07,0,0,BufBajtowOdebr,BufBajtowDoPosl);

  FillChar(BufBajtowOdebr,SizeOf(BufBajtowOdebr),0);
  Wynik := RSSequence($24,1,0,BufBajtowOdebr,BufBajtowDoPosl);
end;

{******************************************************************************}
{test bajtu statusu}
{******************************************************************************}

procedure TForm1.StartBajtClick(Sender: TObject);
var Licznik           :dword;
    LicznikTN         :dword;
    LicznikTO         :dword;
    LicznikBl         :dword;
    LicznikStOK       :dword;
    LicznikStBe       :dword;
    LicznikZlaOdp     :dword;
    LicznikNak        :dword;
    LicznikZmSt       :dword;
    StatusPoprzedni   :byte;
    Status            :byte;
    PierwszePrzejscie :boolean;
    BufBajtowOdebr    :tBuforBajtow;
    BufBajtowDoPOsl   :tBuforBajtow;
    Wynik             :byte;
begin
  Przerwij := False;
  StatusPoprzedni := 0;
  CzyscPola;

  Licznik := 0;
  LicznikTN := 0;
  LicznikTO := 0;
  LicznikBl := 0;
  LicznikStOK := 0;
  LicznikStBe := 0;
  LicznikZlaOdp := 0;
  LicznikNak := 0;
  LicznikZmSt := 0;

  if not MozliwaPraca then begin
    MessageDlg('Nie zainicjowany port', mtInformation, [mbOk], 0);
    exit;
  end;

  StartBajt.Enabled := false;
  Stop.Enabled := true;

  GBParametry.Enabled := False;
  GBDaneSt.Enabled := False;
  GBTest.Enabled := False;
  GBBledy.Enabled := False;

  PierwszePrzejscie := true;
  Czas := 0;

  Timer1.Enabled := true;
  repeat
   Application.ProcessMessages;

   FillChar(BufBajtowDoPosl,SizeOf(BufBajtowDoPosl),0);
   Wynik := RSSequence($5B,2,0,BufBajtowOdebr,BufBajtowDoPosl);
   JestBladInit;

   inc(Licznik);
   if Odswierz then
      EditLicznik.Text := IntToStr(Licznik);
   case Wynik of
        0: begin
             inc(LicznikStOk);

             if Odswierz then begin
                EditStatusOk.Text := IntToStr(LicznikStOk);
                Odswierz := false;
             end;

             Status := BufBajtowOdebr[1];
             if PierwszePrzejscie then begin
                EditStatus.Text := IntToStr(Status);
                PierwszePrzejscie := false;
                StatusPoprzedni := Status;
             end;

             if Status <> StatusPoprzedni then begin
                inc(LicznikZmSt);
                EditStZmiana.Text := IntToStr(LicznikZmSt);
                EditStatus.Text := IntToStr(Status);
             end;
             StatusPoprzedni := Status;
           end;

        20: begin
              inc(LicznikTN);
              EditTNad.Text := IntToStr(LicznikTN);
              inc(LicznikStBe);
              EditStatusBe.Text := IntToStr(LicznikStBe);
            end;

        21: begin
              inc(LicznikTO);
              EditTOdb.Text := IntToStr(LicznikTO);
              inc(LicznikStBe);
              EditStatusBe.Text := IntToStr(LicznikStBe);
            end;

        23: begin
              inc(LicznikZlaOdp);
              EditZlaOdp.Text := IntToStr(LicznikZlaOdp);
              inc(LicznikStBe);
              EditStatusBe.Text := IntToStr(LicznikStBe);
            end;

        24: begin
              inc(LicznikNak);
              EditNak.Text := IntToStr(LicznikNak);
              inc(LicznikStBe);
              EditStatusBe.Text := IntToStr(LicznikStBe);
            end

        else
          begin
            inc(LicznikBl);
            EditBledy.Text := IntToStr(LicznikBl);
            inc(LicznikStBe);
            EditStatusBe.Text := IntToStr(LicznikStBe);
          end;
   end;
   Application.ProcessMessages;
  until Przerwij;

  Timer1.Enabled := false;

  StartBajt.Enabled := true;
  Stop.Enabled := false;
  GBParametry.Enabled := true;
  GBDaneSt.Enabled := true;
  GBTest.Enabled := true;
  GBBledy.Enabled := true;
end;

{******************************************************************************}
{koniec testu bajtu statusu}
{******************************************************************************}
procedure TForm1.StopClick(Sender: TObject);
begin
  Przerwij := True;
  Form1.StatusBar1.Panels[1].Text  := '';
  Form1.StatusBar1.Panels[0].Text  := '';
end;

{******************************************************************************}
{raport fiskalny dobowy}
{******************************************************************************}

procedure TForm1.SBRaportClick(Sender: TObject);
begin
  CzyscPola;
  if not MozliwaPraca then begin
    MessageDlg('Nie zainicjowany port', mtInformation, [mbOk], 0);
    exit;
  end;

  FillChar(BufBajtowOdebr,SizeOf(BufBajtowOdebr),0);

  Wynik := RSSequence($25,1,0,BufBajtowOdebr,BufBajtowDoPosl);
  if Wynik <> 0 then
    MessageDlg('Wystpi bd nr ' + IntToStr(Wynik)+'.', mtInformation, [mbOk], 0)
end;

{******************************************************************************}
{test wyswietlacza klienta}
{******************************************************************************}

procedure TForm1.SBWyswietlaczClick(Sender: TObject);
var i :integer;
begin
  CzyscPola;
  if not MozliwaPraca then begin
    MessageDlg('Nie zainicjowany port', mtInformation, [mbOk], 0);
    exit;
  end;

  for i:= 1 to 9 do
    BufBajtowDoPosl[i*2] := $2E;
  for i:= 1 to 9 do
    BufBajtowDoPosl[i*2-1] := $38;

  BufBajtowDoPosl[19] := $0A;

  BufBajtowDoPosl[20] := $1B;
  BufBajtowDoPosl[21] := $53;

  Wynik := RSSequence($52,1,21,BufBajtowOdebr,BufBajtowDoPosl);
  if Wynik <> 0 then
    MessageDlg('Wystpi bd nr ' + IntToStr(Wynik)+'.', mtInformation, [mbOk], 0)
end;

{******************************************************************************}
{wprowadzenie stawek VAT}
{******************************************************************************}

procedure TForm1.SBStawkiVatClick(Sender: TObject);
begin
  CzyscPola;
  if not MozliwaPraca then begin
    MessageDlg('Nie zainicjowany port', mtInformation, [mbOk], 0);
    exit;
  end;

    BufBajtowDoPosl[1] := $16;
    BufBajtowDoPosl[2] := $07;
    BufBajtowDoPosl[3] := $00;
    BufBajtowDoPosl[4] := $FF;

  Wynik := RSSequence($44,1,4,BufBajtowOdebr,BufBajtowDoPosl);
  if Wynik = 0 then
    MessageDlg('Wprowadzono stawki VAT.', mtInformation, [mbOk], 0)
  else
    MessageDlg('Podczas zapisu stawek VAT wystpi bd nr ' + IntToStr(Wynik)+'.', mtInformation, [mbOk], 0)
end;

{******************************************************************************}
{przelij aktualne stawki podatku VAT}
{******************************************************************************}

procedure TForm1.SBOdczytajStawkiClick(Sender: TObject);
begin
  CzyscPola;
  if not MozliwaPraca then begin
    MessageDlg('Nie zainicjowany port', mtInformation, [mbOk], 0);
    exit;
  end;

  FillChar(BufBajtowOdebr,SizeOf(BufBajtowOdebr),0);
  Wynik := RSSequence($D0,10,0,BufBajtowOdebr,BufBajtowDoPosl);
  if Wynik = 0 then
    MessageDlg('Odczytano stawki VAT.', mtInformation, [mbOk], 0)
  else
    MessageDlg('Podczas odczytu stawek VAT wystpi bd nr ' + IntToStr(Wynik)+'.', mtInformation, [mbOk], 0)

end;

{******************************************************************************}
{wyjcie z aplikacji}
{******************************************************************************}

procedure TForm1.KoniecClick(Sender: TObject);
begin
  Przerwij := true;
  Application.Terminate;
end;

end.
